



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQLite学习笔记(八)&amp;&amp;sqlite实现架构</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQLite学习笔记(八)&amp;&amp;sqlite实现架构</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 13:31:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>该系列的前面一些文章我重点讲了sqlite的核心功能，比如封锁机制，共享缓存，以及事务管理等。但对于sqlite的整体没有作一个全面的介绍，本文将从实现的层面，整体介绍sqlite的框架、各个核心模块以及功能。后续再针对核心模块作进一步的分析。我们说sqlite是一个关系型的嵌入式数据库。提到关系型数据库，我们会想到诸如oracle，mysql，sqlserver等主流数据库，它们的核心功能点在于支持SQL，支持事务；提到嵌入式数据库，我们会想到berkeleyDB，sqlite，它们核心在于嵌入式，即作为应用程序的一部分，没有独立的进程。Sqlite当然具有以上特性，那么这些特性在sqlite中如何实现，有哪些模块实现呢？</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/176539/201511/176539-20151114115522900-1703709758.png" /></p>
<p>图1</p>
<p>如图1，Sqlite由7个模块组成，分别是词法分析器(Tokenizer)，解析器(Parser)，代码生成器(Code generator)，虚拟机(Virtual machine)，Tree模块，Pager模块以及OS接口。前面3个模块主要用于解析SQL语句或者命令，后面四个模块则主要用于执行。虽然各个数据库的模块划分可能千差万别，但基本功能是一致的。为了解析SQL，一定有词法+语法分析+语义分析；为了能执行SQL语句，一定需要先生成执行计划，并通过优化器选择最优的执行计划；为了实现事务的ACID特性，一定有事务管理模块，并发控制模块和故障恢复模块等。其实说白了就是这么些东西，针对sqlite，我们看看这些核心的功能分别是由具体哪个模块实现的。</p>
<p>Tokenizer：将SQL语句进行分词</p>
<p>Parser：将词法分析器的输出作为它的输入，结合语义(利用元数据判断，比如表是否存在)，生成一个语法树，并最终转换化为执行计划树，这个过程中包含了通过优化器选择最佳路径。所以说整个词法分析+语法分析+语义分析+代价优化都在Parser这个模块中实现。</p>
<p>Code generator：将执行计划树生成虚拟机指令集，这个是sqlite比较独特的地方，主要为虚拟机做准备。</p>
<p>Virtual machine：通过执行代码生成器产生的指令集，来执行SQL语句满足用户的需求。通过操作数据库文件中的记录，来查询或修改数据。</p>
<p>The tree：将用户的记录通过B树结构来管理，每个用户表通过一个B+树管理，每个索引通过一个B树管理。VM通过tree模块实现从Btree中查询、插入、删除、更新记录，或者创建/删除一个Btree等。所有这些操作接口都有tree模块封装。VM执行指令时，直接调用接口即可。</p>
<p>The pager：在tree模块看来，所有的B树的节点都是在内存中的，tree模块不直接与数据库文件打交道。Pager模块负责直接与数据库文件交互，它管理缓存，并负责内外存交互。同时它还负责并发控制和故障恢复。所以pager模块是sqlite中核心模块之一，事务的ACID特性全部靠pager模块实现。</p>
<p>The operating system interface：针对不同的操作系统，提供统一的操作文件接口。Pager模块并不关心底层的硬件和操作系统，在它看来，只需要调用统一的接口就能达到读写文件的目的。当然不仅限于此，除了文件IO，mutex，sleep，随机数生成的统一接口也是该模块封装的。</p>
<p>可以看到，sqlite每个模块的功能边界非常清晰，模块间虽相互依赖，但耦合度很低，因此sqlite扩展相对容易。麻雀虽小，五脏俱全用在sqlite身上再合适不过了，哈哈！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2ww63q.html">函数式Android编程（II）：Kotlin语言的集合操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2w5doq.html">&lpar;九&rpar;Maven坐标详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ey5xz9.html">Swift 备忘单和快速参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o41oxq.html">【百度文库课程】Java语言基础与OOP入门学习笔记一</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1po0zq.html">iOS 里面 Swift与Objective-C混编，Swift与C&plus;&plus;混编的一些比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gkoml8.html">ubuntu下怎么解决python &amp;quot&semi;Non-ASCII character&amp;quot&semi;错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954350q.html">【WPF】Winform调用WPF窗体注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdllkk8.html">Loadrunner：POP3协议录制收信，使用foxmail录制到的脚本为空</a>
		</li>
						<li><a href="https://www.batexi.com/a/qded4x79.html">jquery操作select 的value和text值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wejyoq.html">hihocoder 1077线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoom53q.html">hibernate 管理 Session&lpar;单独使用session，不spring&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejdkz8.html">Linux C语言操作MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpozej9.html">Design Pattern&mdash;&mdash;Factory&lowbar;DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkymp08.html">HTML的基本结构与标签的初步了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexwy2q.html">angular封装七牛云图片上传，解决同一页面多个上传按钮分别上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvg719.html">java web 初学</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv14kzoq.html">spring boot&plus;mybatis&plus;quartz项目的搭建完整版</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyg40n9.html">了解UI Automator Viewer</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmeyg8.html">thinkphp5 图片下载保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkrj49.html">linux第四次读书笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j17eg9.html">记录一则ORA-12154，ORA-12560解决过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/m960nl49.html">「UI 测试自动化selenium」汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o16g1q.html">HTML基本结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqll4nxq.html">从零开始学习jQuery &lpar;三&rpar; 管理jQuery包装集</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwv25y8.html">Github团队开发示例（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2541wq.html">WCF学习系列三--【WCF Interview Questions &ndash; Part 3  翻译系列】</a>
			</li>
						<li><a href="https://www.batexi.com/a/495g4kzq.html">autocad2008&plus;C&num;2008开发中设置自动加载dll</a>
			</li>
						<li><a href="https://www.batexi.com/a/495g636q.html">csharp&colon; MySQL Stored Procedure using DAL</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyyp5jq.html">【转】mysql的union、left join、 right join、 inner join和视图学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7opl18.html">HDU  5475（2015 ICPC上海站网络赛）--- An easy problem（线段树点修改）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
